diff --git a/src/backend/utils/cache/relcache.c b/src/backend/utils/cache/relcache.c
index 559ba9cdb2..e4b3a4e855 100644
--- a/src/backend/utils/cache/relcache.c
+++ b/src/backend/utils/cache/relcache.c
@@ -2417,6 +2417,9 @@ RelationReloadNailed(Relation relation)
 
 		pg_class_tuple = ScanPgRelation(RelationGetRelid(relation),
 										true, false);
+		if (!HeapTupleIsValid(pg_class_tuple))
+			elog(ERROR, "could not find pg_class entry for %u",
+				 RelationGetRelid(relation));
 		relp = (Form_pg_class) GETSTRUCT(pg_class_tuple);
 		memcpy(relation->rd_rel, relp, CLASS_TUPLE_SIZE);
 		heap_freetuple(pg_class_tuple);
